osg::Callback Class Reference

`#include <Callback>`

Inheritance diagram for osg::Callback:

## Public Member Functions

| Callback ()
| Callback (const Callback &cb, const CopyOp &copyop)
| META_Object (osg, Callback)
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual NodeCallback * | asNodeCallback ()
virtual const NodeCallback * | asNodeCallback () const
virtual StateAttributeCallback * | asStateAttributeCallback ()
virtual const StateAttributeCallback * | asStateAttributeCallback () const
virtual UniformCallback * | asUniformCallback ()
virtual const UniformCallback * | asUniformCallback () const
virtual DrawableUpdateCallback * | asDrawableUpdateCallback ()
virtual const DrawableUpdateCallback * | asDrawableUpdateCallback () const
virtual DrawableEventCallback * | asDrawableEventCallback ()
virtual const DrawableEventCallback * | asDrawableEventCallback () const
virtual DrawableCullCallback * | asDrawableCullCallback ()
virtual const DrawableCullCallback * | asDrawableCullCallback () const
virtual osgGA::EventHandler * | asEventHandler ()
virtual const osgGA::EventHandler * | asEventHandler () const
virtual bool | run (osg::Object *object, osg::Object *data)
bool | traverse (osg::Object *object, osg::Object *data)
void | setNestedCallback (osg::Callback *cb)
osg::Callback * | getNestedCallback ()
const osg::Callback * | getNestedCallback () const
void | addNestedCallback (osg::Callback *nc)
void | removeNestedCallback (osg::Callback *nc)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Callback ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

ref_ptr< Callback > | _nestedCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Constructor & Destructor Documentation

## Callback() [1/2]

osg::Callback::Callback | ( |  | ) |

inline

Referenced by osgPresentation::AnimationMaterialCallback::AnimationMaterialCallback(), asCallback(), asCallback(), Callback(), osg::CallbackObject::CallbackObject(), osg::DrawableCullCallback::DrawableCullCallback(), osg::DrawableEventCallback::DrawableEventCallback(), osg::DrawableUpdateCallback::DrawableUpdateCallback(), osg::Camera::DrawCallback::DrawCallback(), osgGA::EventHandler::EventHandler(), osgGA::GUIEventHandler::GUIEventHandler(), osgViewer::InteractiveImageHandler::InteractiveImageHandler(), META_Object(), osg::NodeCallback::NodeCallback(), osg::StateAttributeCallback::StateAttributeCallback(), osg::UniformCallback::UniformCallback(), osgAnimation::UpdateMorphGeometry::UpdateMorphGeometry(), and osgAnimation::UpdateRigGeometry::UpdateRigGeometry().

## Callback() [2/2]

osg::Callback::Callback | ( | const Callback & | cb,
|  | const CopyOp & | copyop )

inline

References _nestedCallback, Callback(), and osg::Object::Object().

## ~Callback()

virtual osg::Callback::~Callback | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addNestedCallback()

void osg::Callback::addNestedCallback | ( | osg::Callback * | nc | ) |

inline

References _nestedCallback.

## asCallback() [1/2]

virtual Callback * osg::Callback::asCallback | ( |  | ) |

inline virtual

Convert 'this' into a Callback pointer if Object is a Callback, otherwise return 0. Equivalent to dynamic_cast<Callback*>(this).

Reimplemented from osg::Object.

Reimplemented in osgAnimation::AnimationUpdateCallback< osg::NodeCallback >, osgAnimation::AnimationUpdateCallback< osg::StateAttributeCallback >, and osgAnimation::AnimationUpdateCallback< osg::UniformCallback >.

References Callback().

## asCallback() [2/2]

virtual const Callback * osg::Callback::asCallback | ( |  | ) | const

inline virtual

convert 'const this' into a const Callback pointer if Object is a Callback, otherwise return 0. Equivalent to dynamic_cast<const Callback*>(this).

Reimplemented from osg::Object.

References Callback().

## asCallbackObject() [1/2]

virtual CallbackObject * osg::Callback::asCallbackObject | ( |  | ) |

inline virtual

Convert 'this' into a CallbackObject pointer if Object is a CallbackObject, otherwise return 0. Equivalent to dynamic_cast<CallbackObject*>(this).

Reimplemented from osg::Object.

Reimplemented in osg::CallbackObject, osgAnimation::AnimationUpdateCallback< osg::NodeCallback >, osgAnimation::AnimationUpdateCallback< osg::StateAttributeCallback >, and osgAnimation::AnimationUpdateCallback< osg::UniformCallback >.

Referenced by osgGA::EventVisitor::apply().

## asCallbackObject() [2/2]

virtual const CallbackObject * osg::Callback::asCallbackObject | ( |  | ) | const

inline virtual

convert 'const this' into a const CallbackObject pointer if Object is a CallbackObject, otherwise return 0. Equivalent to dynamic_cast<const CallbackObject*>(this).

Reimplemented from osg::Object.

Reimplemented in osg::CallbackObject.

## asDrawableCullCallback() [1/2]

virtual DrawableCullCallback * osg::Callback::asDrawableCullCallback | ( |  | ) |

inline virtual

Reimplemented in osg::ClusterCullingCallback, osg::DrawableCullCallback, and osgViewer::InteractiveImageHandler.

## asDrawableCullCallback() [2/2]

virtual const DrawableCullCallback * osg::Callback::asDrawableCullCallback | ( |  | ) | const

inline virtual

Reimplemented in osg::ClusterCullingCallback, osg::DrawableCullCallback, and osgViewer::InteractiveImageHandler.

## asDrawableEventCallback() [1/2]

virtual DrawableEventCallback * osg::Callback::asDrawableEventCallback | ( |  | ) |

inline virtual

Reimplemented in osg::DrawableEventCallback, osgGA::EventHandler, osgViewer::InteractiveImageHandler, and osgVolume::PropertyAdjustmentCallback.

Referenced by osgGA::EventVisitor::apply().

## asDrawableEventCallback() [2/2]

virtual const DrawableEventCallback * osg::Callback::asDrawableEventCallback | ( |  | ) | const

inline virtual

Reimplemented in osg::DrawableEventCallback, osgGA::EventHandler, osgViewer::InteractiveImageHandler, and osgVolume::PropertyAdjustmentCallback.

## asDrawableUpdateCallback() [1/2]

virtual DrawableUpdateCallback * osg::Callback::asDrawableUpdateCallback | ( |  | ) |

inline virtual

Reimplemented in osg::DrawableUpdateCallback.

Referenced by osgUtil::UpdateVisitor::apply().

## asDrawableUpdateCallback() [2/2]

virtual const DrawableUpdateCallback * osg::Callback::asDrawableUpdateCallback | ( |  | ) | const

inline virtual

Reimplemented in osg::DrawableUpdateCallback.

## asEventHandler() [1/2]

virtual osgGA::EventHandler * osg::Callback::asEventHandler | ( |  | ) |

inline virtual

Reimplemented in osgGA::EventHandler, osgViewer::InteractiveImageHandler, and osgVolume::PropertyAdjustmentCallback.

Referenced by osgGA::EventVisitor::apply().

## asEventHandler() [2/2]

virtual const osgGA::EventHandler * osg::Callback::asEventHandler | ( |  | ) | const

inline virtual

Reimplemented in osgGA::EventHandler, osgViewer::InteractiveImageHandler, and osgVolume::PropertyAdjustmentCallback.

## asNodeCallback() [1/2]

virtual NodeCallback * osg::Callback::asNodeCallback | ( |  | ) |

inline virtual

Reimplemented in osg::ClusterCullingCallback, osg::NodeCallback, osgGA::EventHandler, osgViewer::InteractiveImageHandler, and osgVolume::PropertyAdjustmentCallback.

Referenced by osgGA::EventVisitor::apply(), and osgUtil::UpdateVisitor::apply().

## asNodeCallback() [2/2]

virtual const NodeCallback * osg::Callback::asNodeCallback | ( |  | ) | const

inline virtual

Reimplemented in osg::ClusterCullingCallback, osg::NodeCallback, osgGA::EventHandler, osgViewer::InteractiveImageHandler, and osgVolume::PropertyAdjustmentCallback.

## asStateAttributeCallback() [1/2]

virtual StateAttributeCallback * osg::Callback::asStateAttributeCallback | ( |  | ) |

inline virtual

Reimplemented in osg::StateAttributeCallback.

## asStateAttributeCallback() [2/2]

virtual const StateAttributeCallback * osg::Callback::asStateAttributeCallback | ( |  | ) | const

inline virtual

Reimplemented in osg::StateAttributeCallback.

## asUniformCallback() [1/2]

virtual UniformCallback * osg::Callback::asUniformCallback | ( |  | ) |

inline virtual

Reimplemented in osg::UniformCallback.

## asUniformCallback() [2/2]

virtual const UniformCallback * osg::Callback::asUniformCallback | ( |  | ) | const

inline virtual

Reimplemented in osg::UniformCallback.

## getNestedCallback() [1/2]

osg::Callback * osg::Callback::getNestedCallback | ( |  | ) |

inline

References _nestedCallback.

Referenced by osg::Node::removeCullCallback(), osg::Node::removeEventCallback(), osg::Camera::removeFinalDrawCallback(), osg::Camera::removeInitialDrawCallback(), osg::Camera::removePostDrawCallback(), osg::Camera::removePreDrawCallback(), and osg::Node::removeUpdateCallback().

## getNestedCallback() [2/2]

const osg::Callback * osg::Callback::getNestedCallback | ( |  | ) | const

inline

References _nestedCallback.

## META_Object()

osg::Callback::META_Object | ( | osg | ,
|  | Callback | )

References Callback().

## removeNestedCallback()

void osg::Callback::removeNestedCallback | ( | osg::Callback * | nc | ) |

inline

References _nestedCallback.

## run()

virtual bool osg::Callback::run | ( | osg::Object * | object,
|  | osg::Object * | data )

inline virtual

Invoke the callback, first parameter is the Object that the callback is attached to, the second parameter, the data, is typically the NodeVisitor that is invoking the callback. The run(..) method may be overridden by users directly, or if the user is using one of the old style callbacks such as NodeCallback or Drawable::UpdateCallback then you can just override the appropriate callback method on those callback subclasses. If you are implementing your own callback then one should call traverse() to make sure nested callbacks and visitor traversal() is completed.

Reimplemented in osg::CallbackObject, osg::ClusterCullingCallback, osg::DrawableCullCallback, osg::DrawableEventCallback, osg::DrawableUpdateCallback, osg::NodeCallback, osg::StateAttributeCallback, osg::StateSet::Callback, osg::UniformCallback, osgGA::EventHandler, osgShadow::MinimalDrawBoundsShadowMap::CameraCullCallback, osgViewer::InteractiveImageHandler, and osgVolume::PropertyAdjustmentCallback.

References traverse().

Referenced by osgGA::EventVisitor::apply(), osgUtil::UpdateVisitor::apply(), osgGA::EventVisitor::handle_callbacks_and_traverse(), osgUtil::UpdateVisitor::handle_callbacks_and_traverse(), osgUtil::CullVisitor::handle_cull_callbacks_and_accept(), osgUtil::CullVisitor::handle_cull_callbacks_and_traverse(), osgViewer::InteractiveImageHandler::run(), and osgVolume::PropertyAdjustmentCallback::run().

## setNestedCallback()

void osg::Callback::setNestedCallback | ( | osg::Callback * | cb | ) |

inline

References _nestedCallback.

Referenced by osg::Node::removeCullCallback(), osg::Node::removeEventCallback(), osg::Camera::removeFinalDrawCallback(), osg::Camera::removeInitialDrawCallback(), osg::Camera::removePostDrawCallback(), osg::Camera::removePreDrawCallback(), and osg::Node::removeUpdateCallback().

## traverse()

bool osg::Callback::traverse | ( | osg::Object * | object,
|  | osg::Object * | data )

traverse the nested callbacks or call NodeVisitor::traverse() if the object is Node, and data is NodeVisitor.

Referenced by osgAnimation::UpdateUniform< T >::operator()(), run(), and osgShadow::MinimalDrawBoundsShadowMap::CameraCullCallback::run().

## Member Data Documentation

## _nestedCallback

ref_ptr<Callback> osg::Callback::_nestedCallback

protected

Referenced by addNestedCallback(), Callback(), getNestedCallback(), getNestedCallback(), osg::Camera::DrawCallback::releaseGLObjects(), removeNestedCallback(), osg::Camera::DrawCallback::resizeGLObjectBuffers(), osg::Camera::DrawCallback::run(), and setNestedCallback().

The documentation for this class was generated from the following file:

- Callback